# OZCpoint2 http://www.est.hi-ho.ne.jp/atamadekkati/ 
# 桝目に構造点（ガイドポイント、補助点）を作る。
# 2009/09/25 ver1.00 作成
#
# 使用者の自己責任でご使用下さい。
#

require 'sketchup.rb'

#============= メインプログラム =============
def ozcpoint2
  model = Sketchup.active_model
  entities = model.entities
  bbox = model.bounds

# プロンプト
  prompts=["始点Ｘ座標", "始点Ｙ座標","始点Ｚ座標","Ｘ間隔", "Ｙ間隔","Ｚ間隔","Ｘ個数", "Ｙ個数","Ｚ個数"]
  values=[0.mm, 0.mm, 0.mm, 910.mm, 910.mm, 2400.mm, 1, 1, 1]              #プロンプトに表示する初期値
  results=inputbox prompts, values, "ガイドをマス目に作ります。"
  return if not results
  xzahyo=results[0]
  yzahyo=results[1]
  zzahyo=results[2]
  xstep=results[3]
  ystep=results[4]
  zstep=results[5]
  xnum=results[6]
  ynum=results[7]
  znum=results[8]

# 作図
  Sketchup.active_model.start_operation("マス目ガイド")

	for iz in 1..znum
		for iy in 1..ynum
			for ix in 1..xnum
			  constpoint = entities.add_cpoint [xzahyo + (ix - 1) * xstep, yzahyo + (iy - 1) * ystep, zzahyo + (iz - 1) * zstep ]
			end
		end
	end

  Sketchup.active_model.commit_operation
end

#=============================================================================
# Add a menu 
if( not $ozcpoint2_menu_loaded )
  add_separator_to_menu("Tools")
  ozcpoint2_menu = UI.menu("Tools").add_item("マス目ガイド") { ozcpoint2 }
  $ozcpoint2_menu_loaded = true
end